//
// DO NOT MODIFY! THIS IS AUTOGENERATED FILE!
//
namespace Xilium.CefGlue
{
    using System;
    using System.Collections.Generic;
    using System.Diagnostics;
    using System.Runtime.InteropServices;
    using System.Threading;
    using Xilium.CefGlue.Interop;
    
    // Role: HANDLER
    public abstract unsafe partial class CefBrowserProcessHandler
    {
        private static Dictionary<IntPtr, CefBrowserProcessHandler> _roots = new Dictionary<IntPtr, CefBrowserProcessHandler>();
        
        private int _refct;
        private cef_browser_process_handler_t* _self;
        
        private cef_browser_process_handler_t.add_ref_delegate _ds0;
        private cef_browser_process_handler_t.release_delegate _ds1;
        private cef_browser_process_handler_t.has_one_ref_delegate _ds2;
        private cef_browser_process_handler_t.has_at_least_one_ref_delegate _ds3;
        private cef_browser_process_handler_t.on_context_initialized_delegate _ds4;
        private cef_browser_process_handler_t.on_before_child_process_launch_delegate _ds5;
        private cef_browser_process_handler_t.get_print_handler_delegate _ds6;
        private cef_browser_process_handler_t.on_schedule_message_pump_work_delegate _ds7;
        
        protected CefBrowserProcessHandler()
        {
            _self = cef_browser_process_handler_t.Alloc();
        
            _ds0 = new cef_browser_process_handler_t.add_ref_delegate(add_ref);
            _self->_base._add_ref = Marshal.GetFunctionPointerForDelegate(_ds0);
            _ds1 = new cef_browser_process_handler_t.release_delegate(release);
            _self->_base._release = Marshal.GetFunctionPointerForDelegate(_ds1);
            _ds2 = new cef_browser_process_handler_t.has_one_ref_delegate(has_one_ref);
            _self->_base._has_one_ref = Marshal.GetFunctionPointerForDelegate(_ds2);
            _ds3 = new cef_browser_process_handler_t.has_at_least_one_ref_delegate(has_at_least_one_ref);
            _self->_base._has_at_least_one_ref = Marshal.GetFunctionPointerForDelegate(_ds3);
            _ds4 = new cef_browser_process_handler_t.on_context_initialized_delegate(on_context_initialized);
            _self->_on_context_initialized = Marshal.GetFunctionPointerForDelegate(_ds4);
            _ds5 = new cef_browser_process_handler_t.on_before_child_process_launch_delegate(on_before_child_process_launch);
            _self->_on_before_child_process_launch = Marshal.GetFunctionPointerForDelegate(_ds5);
            _ds6 = new cef_browser_process_handler_t.get_print_handler_delegate(get_print_handler);
            _self->_get_print_handler = Marshal.GetFunctionPointerForDelegate(_ds6);
            _ds7 = new cef_browser_process_handler_t.on_schedule_message_pump_work_delegate(on_schedule_message_pump_work);
            _self->_on_schedule_message_pump_work = Marshal.GetFunctionPointerForDelegate(_ds7);
        }
        
        ~CefBrowserProcessHandler()
        {
            Dispose(false);
        }
        
        protected virtual void Dispose(bool disposing)
        {
            if (_self != null)
            {
                cef_browser_process_handler_t.Free(_self);
                _self = null;
            }
        }
        
        private void add_ref(cef_browser_process_handler_t* self)
        {
            if (Interlocked.Increment(ref _refct) == 1)
            {
                lock (_roots) { _roots.Add((IntPtr)_self, this); }
            }
        }
        
        private int release(cef_browser_process_handler_t* self)
        {
            if (Interlocked.Decrement(ref _refct) == 0)
            {
                lock (_roots) { _roots.Remove((IntPtr)_self); }
                return 1;
            }
            return 0;
        }
        
        private int has_one_ref(cef_browser_process_handler_t* self)
        {
            return _refct == 1 ? 1 : 0;
        }
        
        private int has_at_least_one_ref(cef_browser_process_handler_t* self)
        {
            return _refct != 0 ? 1 : 0;
        }
        
        internal cef_browser_process_handler_t* ToNative()
        {
            add_ref(_self);
            return _self;
        }
        
        [Conditional("DEBUG")]
        private void CheckSelf(cef_browser_process_handler_t* self)
        {
            if (_self != self) throw ExceptionBuilder.InvalidSelfReference();
        }
        
    }
}
